DECLARE SUB REV (A$)
DECLARE SUB MILLIDELAY (msecs%)
DECLARE SUB PrintF (SX%, Y%, XSIZE%, YSIZE%, S AS STRING)
DEFINT A-Z
SCREEN 12: CLS
MILLIDELAY 0

DO
DO
COLOR 10
LOCATE 1, 1: PRINT "Type a sentence (`Exit' to quit) - "
COLOR 5
LOCATE 3, 1: PRINT "?"; : LINE INPUT T$
T$ = RTRIM$(RIGHT$(T$, 40))
IF UCASE$(T$) = "EXIT" THEN
END
END IF
LOOP UNTIL T$ <> ""

MAX.X = 30
MAX.Y = 64
L = LEN(T$)

CLS

H = 1
V = 1
X = MAX.X
Y = MAX.Y

DO
TC = INT(RND * 15) + 1
COLOR TC: GOSUB SHOW.TEXT
DO
IF H OR V THEN
COLOR TC: GOSUB SHOW.TEXT
MILLIDELAY 20
COLOR 0: GOSUB SHOW.TEXT
X = X + H
Y = Y + V
IF X > MAX.X THEN H = -1: X = MAX.X
IF Y > MAX.Y THEN V = -1: Y = MAX.Y
IF X < 0 THEN H = 1: X = 0: REV T$
IF Y < 0 THEN V = 1: Y = 0
END IF
K$ = UCASE$(INKEY$)
LOOP WHILE K$ = ""
SELECT CASE K$
CASE CHR$(0) + "H": V = -1
CASE CHR$(0) + "P": V = 1
CASE CHR$(0) + "K": H = -1
CASE CHR$(0) + "M": H = 1
CASE " ": H = 0: V = 0
CASE CHR$(27)
EXIT DO
END SELECT
LOOP
LOOP
SHOW.TEXT:
TX = (640 - ((X * L) * 8)) / 2
TY = (480 - (Y * 8)) / 2
PrintF TX, TY + 50, X, Y, T$
RETURN

SUB MILLIDELAY (msecs) STATIC
IF sysfact& THEN                   'Did we calc- system speed yet?
        IF msecs THEN                  'have to want a delay
            count& = (sysfact& * msecs) \ -54    'calc- # of loops needed
            DO
                count& = count& + 1         'negative - add to get to 0
                IF count& = z THEN EXIT DO  'when its 0 we're done
            LOOP UNTIL t2 = PEEK(&H6C)      'make it the same as loop below
        END IF
    ELSE                               'if sysfact& is 0, calc- system speed
        DEF SEG = &H40                 'point to low memory
        t1 = PEEK(&H6C)                'get tick count
        DO
            t2 = PEEK(&H6C)            'get tick count
        LOOP UNTIL t2 <> t1            'wait 'til its a new tick
        DO
            sysfact& = sysfact& + 1         'count number of loops
            IF sysfact& = z THEN EXIT DO    'make it the same as loop above
        LOOP UNTIL t2 <> PEEK(&H6C)         'keep going 'til its a new tick
        t2 = 256                            'prevent the above UNTIL
    END IF
END SUB

SUB PrintF (SX, Y, XSIZE, YSIZE, S AS STRING)

FOR A = 1 TO LEN(S)
X = SX + ((A - 1) * (XSIZE * 8))
XS = X
YS = Y
XM = X + (3 * XSIZE)
YM = Y + (3 * YSIZE)
XE = X + (6 * XSIZE)
YE = Y + (6 * YSIZE)
L$ = MID$(S, A, 1)
XST = ((XM - XS) / 2)
YST = ((YM - YS) / 2)
SELECT CASE UCASE$(L$)
CASE "A"
LINE (XS, YE)-(XM, YS)
LINE (XM, YS)-(XE, YE)
LINE (((XM - XS) / 2) + XS, YM)-((((XM - XS) / 2) * 3) + XS, YM)
CASE "B"
LINE (XS, YS)-((XST / 2) * 5 + XS, YS)
LINE (XS, YS)-(XS, YE)
LINE (XE, YE)-(XS, YE)
LINE (XE, YE)-(XE, YM)
LINE (XE, YM)-(XS, YM)
LINE ((XST / 2) * 5 + XS, YS)-((XST / 2) * 5 + XS, YM)
CASE "C"
LINE (XS, YS)-(XE, YS)
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "D"
LINE (XS, YS)-(XS, YE)
LINE (XS, YS)-(XM, YS)
LINE (XM, YS)-(XE, YM)
LINE (XE, YM)-(XM, YE)
LINE (XM, YE)-(XS, YE)
CASE "E"
LINE (XS, YS)-(XS, YE)
LINE (XS, YS)-(XE, YS)
LINE (XS, YM)-(XE, YM)
LINE (XS, YE)-(XE, YE)
CASE "F"
LINE (XE, YS)-(XS, YS)
LINE (XS, YS)-(XS, YE)
LINE (XS, YM)-(XE, YM)
CASE "G"
LINE (XE, YS)-(XS, YS)
LINE (XS, YE)-(XS, YS)
LINE (XS, YE)-(XE, YE)
LINE (XE, YE)-(XE, YM)
LINE (XE, YM)-(XM, YM)
CASE "H"
LINE (XS, YS)-(XS, YE)
LINE (XE, YE)-(XE, YS)
LINE (XS, YM)-(XE, YM)
CASE "I"
LINE (XM, YS)-(XM, YE)
CASE "J"
LINE (XS, YS)-(XE, YS)
LINE (XM, YS)-(XM, YE)
LINE (XS, YE)-(XM, YE)
CASE "K"
LINE (XS, YS)-(XS, YE)
LINE (XS, YM)-(XE, YS)
LINE (XS, YM)-(XE, YE)
CASE "M"
LINE (XS, YS)-(XS, YE)
LINE (XS, YS)-(XM, YE)
LINE (XM, YE)-(XE, YS)
LINE (XE, YS)-(XE, YE)
CASE "N"
LINE (XS, YS)-(XS, YE)
LINE (XE, YE)-(XE, YS)
LINE (XE, YE)-(XS, YS)
CASE "L"
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "O"
LINE (XE, YS)-(XE, YE)
LINE (XS, YS)-(XE, YS)
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "P"
LINE (XS, YS)-(XS, YE)
LINE (XS, YS)-(XE, YS)
LINE (XE, YS)-(XE, YM)
LINE (XS, YM)-(XE, YM)
CASE "Q"
LINE (XS, YS)-(XM + XST, YS)
LINE (XM + XST, YS)-(XM + XST, YM + YST)
LINE (XM + XST, YM + YST)-(XS, YM + YST)
LINE (XS, YM + YST)-(XS, YS)
LINE (XM, YM)-(XE, YE)
CASE "R"
LINE (XS, YS)-(XS, YE)
LINE (XS, YS)-(XE, YS)
LINE (XE, YS)-(XE, YM)
LINE (XS, YM)-(XE, YM)
LINE (XS, YM)-(XE, YE)
CASE "S"
LINE (XS, YS)-(XE, YS)
LINE (XS, YM)-(XS, YS)
LINE (XS, YM)-(XE, YM)
LINE (XE, YE)-(XE, YM)
LINE (XE, YE)-(XS, YE)
CASE "T"
LINE (XM, YS)-(XM, YE)
LINE (XS, YS)-(XE, YS)
CASE "U"
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
LINE (XE, YE)-(XE, YS)
CASE "V"
LINE (XS, YS)-(XM, YE)
LINE (XM, YE)-(XE, YS)
CASE "W"
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XM, YS)
LINE (XM, YS)-(XE, YE)
LINE (XE, YE)-(XE, YS)
CASE "X"
LINE (XE, YE)-(XS, YS)
LINE (XE, YS)-(XS, YE)
CASE "Y"
LINE (XS, YS)-(XM, YM)
LINE (XE, YS)-(XM, YM)
LINE (XM, YM)-(XM, YE)
CASE "Z"
LINE (XS, YS)-(XE, YS)
LINE (XE, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "!"
LINE (XM, YM)-(XM, YS)
PSET (XM, YE)
CASE "1"
LINE (XS, YM)-(XM, YS)
LINE (XM, YS)-(XM, YE)
LINE (XS, YE)-(XE, YE)
CASE "2"
LINE (XS, YS)-(XE, YS)
LINE (XE, YS)-(XE, YM)
LINE (XE, YM)-(XS, YM)
LINE (XS, YM)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "3"
LINE (XS, YS)-(XE, YS)
LINE (XE, YS)-(XE, YE)
LINE (XE, YM)-(XS, YM)
LINE (XS, YE)-(XE, YE)
CASE "4"
LINE (XS, YS)-(XS, YM)
LINE (XE, YM)-(XS, YM)
LINE (XE, YS)-(XE, YE)
CASE "5"
LINE (XS, YS)-(XE, YS)
LINE (XS, YM)-(XS, YS)
LINE (XS, YM)-(XE, YM)
LINE (XE, YE)-(XE, YM)
LINE (XE, YE)-(XS, YE)
CASE "6"
LINE (XS, YS)-(XE, YS)
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
LINE (XE, YE)-(XE, YM)
LINE (XE, YM)-(XS, YM)
CASE "7"
LINE (XS, YS)-(XE, YS)
LINE (XE, YS)-(XE, YE)
CASE "8"
LINE (XS, YM)-(XE, YM)
LINE (XE, YS)-(XE, YE)
LINE (XS, YS)-(XE, YS)
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "9"
LINE (XS, YS)-(XE, YS)
LINE (XS, YS)-(XS, YM)
LINE (XS, YM)-(XE, YM)
LINE (XE, YS)-(XE, YE)
CASE "0"
LINE (XS, YS)-(XE, YE)
LINE (XE, YS)-(XE, YE)
LINE (XS, YS)-(XE, YS)
LINE (XS, YS)-(XS, YE)
LINE (XS, YE)-(XE, YE)
CASE "'", "`"
LINE (XM, YM - YST)-(XM, YS)
CASE CHR$(34)
LINE (XM + XST, YM - YST)-(XM + XST, YS)
LINE (XM - XST, YM - YST)-(XM - XST, YS)
CASE "-"
LINE (XM - XST, YM)-(XM + XST, YM)
CASE "_"
LINE (XM - XST, YE)-(XM + XST, YE)
CASE ","
LINE (XM, YE - YST)-(XM, YE)
CASE "#"
LINE (XS, YS + YST)-(XE, YS + YST)
LINE (XS, YE - YST)-(XE, YE - YST)
LINE (XS + XST, YS)-(XS + XST, YE)
LINE (XE - XST, YS)-(XE - XST, YE)
CASE "*"
LINE (XS, YS)-(XE, YE)
LINE (XS, YE)-(XE, YS)
LINE (XM, YS)-(XM, YE)
LINE (XS, YM)-(XE, YM)
CASE ">"
LINE (XS, YS)-(XE, YM)
LINE (XS, YE)-(XE, YM)
CASE "<"
LINE (XE, YE)-(XS, YM)
LINE (XE, YS)-(XS, YM)
CASE "("
LINE (XE, YE)-(XM, YM)
LINE (XE, YS)-(XM, YM)
CASE ")"
LINE (XS, YS)-(XM, YM)
LINE (XS, YE)-(XM, YM)
CASE "["
LINE (XE, YS)-(XM, YS)
LINE (XM, YS)-(XM, YE)
LINE (XM, YE)-(XE, YE)
CASE "]"
LINE (XS, YS)-(XM, YS)
LINE (XM, YS)-(XM, YE)
LINE (XM, YE)-(XS, YE)
CASE "{"
LINE (XE, YS)-(XM, YS)
LINE (XM, YS)-(XM, YE)
LINE (XM, YE)-(XE, YE)
LINE (XS, YM)-(XM, YM)
CASE "}"
LINE (XS, YS)-(XM, YS)
LINE (XM, YS)-(XM, YE)
LINE (XM, YE)-(XS, YE)
LINE (XE, YM)-(XM, YM)
CASE "+"
LINE (XS, YM)-(XE, YM)
LINE (XM, YS)-(XM, YE)
CASE "="
LINE (XS, YM - YST)-(XE, YM - YST)
LINE (XS, YM + YST)-(XE, YM + YST)
CASE "^"
LINE (XS, YM)-(XM, YS)
LINE (XE, YM)-(XM, YS)
CASE "&"
LINE (XE, YE)-(XS, YM - YST)
LINE (XS, YM - YST)-(XM, YS)
LINE (XE, YM - YST)-(XM, YS)
LINE (XE, YM - YST)-(XS, YM)
LINE (XS, YM)-(XM, YE)
LINE (XE, YM)-(XM, YE)
CASE "?"
LINE (XS, YM - YST)-(XS, YS)
LINE (XE, YS)-(XS, YS)
LINE (XE, YM - YST)-(XE, YS)
LINE (XE, YM - YST)-(XM, YM)
PSET (XM, YE)

END SELECT
NEXT A
END SUB

SUB REV (A$)
FOR A = LEN(A$) TO 1 STEP -1
B$ = B$ + MID$(A$, A, 1)
NEXT A
A$ = B$
END SUB

